# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/22_data.ipynb.

# %% auto 0
__all__ = ['dtype', 'device', 'size', 'npdatasource', 'datasource', 'adata', 'adatas', 'graphtype', 'datatype', 'shaped']

# %% ../nbs/22_data.ipynb 6
#| export


# %% ../nbs/22_data.ipynb 8
from typing import TypeAlias

# %% ../nbs/22_data.ipynb 10
#| export


# %% ../nbs/22_data.ipynb 12
from ptyp import Prototype
from matr import (
    nptype,
    
    anndata, 
    npdatasource as npnpdatasource, 
    bgraph, dgraph, lgraph, 
    kgraph, tgraph, mgraph, 
    klgraph, mlgraph, tlgraph
)

# %% ../nbs/22_data.ipynb 14
from .iter import itertype

from .arrs import array, matrix
from .pand import indextype, seriestype, dataframe
from .trch import pttype, ptsize, ptdevice, tensor

# %% ../nbs/22_data.ipynb 18
@Prototype(nptype, pttype)
class dtype: '''Type of data (e.g. `np.dtype` or `torch.dtype`)'''

# %% ../nbs/22_data.ipynb 20
@Prototype(ptdevice)
class device: '''`torch.device`'''

# %% ../nbs/22_data.ipynb 22
@Prototype(tuple, ptsize, itertype, attrs=dict(dtype=int))
class size: '''size type (e.g. `tuple`, `torch.Size`, `itertype`)'''

# %% ../nbs/22_data.ipynb 24
@Prototype(npnpdatasource)
class npdatasource: '''`numpy.DataSource`''';

# %% ../nbs/22_data.ipynb 25
@Prototype(npdatasource)
class datasource: '''`numpy.DataSource`''';

# %% ../nbs/22_data.ipynb 27
@Prototype(anndata)
class adata: '''`anndata.AnnData`''';

@Prototype(itertype, attrs=dict(dtype=adata))
class adatas: '''`anndata.AnnData`''';

# %% ../nbs/22_data.ipynb 29
@Prototype(bgraph, dgraph, kgraph, tgraph, lgraph, mgraph, tlgraph, klgraph, mlgraph)
class graphtype: 
    '''graph type (e.g. `BaseGraph`, `DataGraph`, `LandmarkGraph`, `kNNGraph`, `TraditionalGraph`, 
    `MNNGraph`, `kNNLandmarkGraph`, `TraditionalLandmarkGraph`, or `MNNLandmarkGraph`)'''

# %% ../nbs/22_data.ipynb 31
@Prototype(array, matrix, adata)
class datatype: '''data type 
    (e.g.  `np.array`, `np.matrix`, `sp.array`, `sp.matrix`,  `np.recarray`, or `anndata`)'''

# %% ../nbs/22_data.ipynb 33
@Prototype(datatype, indextype, seriestype, dataframe, tensor, hasattrs=('shape', ))
class shaped: '''shaped `datatype`'''
